﻿@using Microsoft.AspNetCore.Components
@using SPAWebApp.Client.States
@using SPAWebApp.Shared
@inherits LayoutComponentBase
@inject IUriHelper UriHelper

@if (IsLoggedIn)
{
  <header class="header">
    <a href="">
      <span class="logo">
        <img src="images/logo_transparent.png" alt="Logo">
      </span>
    </a>
    <div class="user-info">
      <div class="top-row px-4">
        <button type="button" class="btn btn-info ml-md-auto" onclick="@RedirectToAccountPage">Привет, @Username</button>
        <button type="button" class="btn btn-danger ml-md-auto" onclick="@LogoutClick">Выйти</button>
      </div>
    </div>

  </header>

  <main>
    <div class="sidebar">
      <NavMenu />
    </div>

    <div class="main">
      <div class="content" style="height: 100%; width: 100%;">
        @Body
      </div>
    </div>
  </main>
}
@functions
{
  [CascadingParameter]
  protected AppState AppState { get; set; }

  protected string Username;
  protected bool IsLoggedIn;
  protected override async Task OnInitAsync()
  {
    IsLoggedIn = await AppState.AccountState.IsLoggedIn();
    if (!IsLoggedIn)
    {
      UriHelper.NavigateTo("/login");
    }
    Username = (await AppState.AccountState.GetUserInfoAsync()).Username;
  }

  async Task LogoutClick()
  {
    await AppState.AccountState.Logout();
    UriHelper.NavigateTo("/login");
  }

  protected void RedirectToAccountPage()
  {
    UriHelper.NavigateTo("/account");
  }

}
